//	VirtualDubMod - Video processing and capture application based on VirtualDub by Avery Lee
//	Copyright (C) 1998-2002 VirtualDubMod Developers
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "about_mod.h"
#include <windows.h>
#include <time.h>
#include <vfw.h>
#include <tchar.h>
#include "starwars.h"
#include "openglwnd.h"

extern HINSTANCE g_hInst;

BOOL APIENTRY AboutModDlgProc( HWND hDlg, UINT message, UINT wParam, LONG lParam) {
	static CStarWarsController *pController;
	static HWND hGL;
	static UINT s_Timer;

    switch (message)
    {
        case WM_INITDIALOG:
			{
				RECT rt;
				PIXELFORMATDESCRIPTOR pfd;

				s_Timer = 0;

				pController = new CStarWarsController(10.0f,0,true);
				if (!pController)
					EndDialog(hDlg, false);
				GetClientRect(hDlg, &rt);

				// setup how i want the window to be
				ZeroMemory(&pfd,sizeof(pfd));
				pfd.nSize = sizeof( pfd );
				pfd.nVersion = 1;
				pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
				pfd.iPixelType = PFD_TYPE_RGBA;
				pfd.cColorBits = 24;
				pfd.cAlphaBits = 8;
				pfd.cDepthBits = 16;
				pfd.iLayerType = PFD_MAIN_PLANE;

				// create the opengl window
				hGL = CreateOpenGLWindow(g_hInst,hDlg,WS_CHILDWINDOW | WS_VISIBLE,0,&rt,pController,&pfd);
				if (!hGL)
					EndDialog(hDlg, false);

				try {
					pController->Start();
				} catch (CError &err) {
					DestroyWindow(hGL);
					EndDialog(hDlg, false);
					// ok we're done now
				}

				s_Timer = SetTimer(hDlg, 1, 20, NULL);
			}
			return TRUE;

		case WM_TIMER:
			{
				if(pController) {
					// do idle processing
					pController->Idle();
					// now redraw
					pController->Draw();
				}
			}
			return TRUE;

		case WM_CLOSE:
			{
				pController = NULL;

				if(s_Timer)
					KillTimer(hDlg, s_Timer);

				if (hGL) DestroyWindow(hGL);
				hGL = NULL;

				EndDialog(hDlg, true);
			}
			return TRUE;
    }
    return FALSE;
}